# Kmre
## Overview
Kmre is a system environment compatible with Android APP designed by Kylin team for "KYLIN Operating system", which is used to meet the diverse needs of users for application software.Users can install and run Android apps in KYLIN operating system by Kmre, such as WeChat, qqlite, stocks, video apps etc.

### Technical Features
1）Kmre is already compatible with a large number of Android apps and takes only a second to boot.

2）There is no performance, Kmre uses graphics hardware.

3）Android App integration with Linux window display.

4）Support multi-program running.

5）Resolution dynamic adaptation,free rotation and UHD.

6）The input method is unified, the system input method can be used in the APP.

7）Same audio device, voice support.

8）Support the use of camera to take photos, video and video calls, support camera hot swap, plug and play.

9）Document,clipping board, application management intercommunication.

10）Support WeChat, qqlite new message notification.

11）Support WeChat tablet mode login and mobile WeChat online at the same time.

12）Support WeChat, qqlite and other Apps to drag and drop files for sharing.

13）Support Android app to access Linux files directly.

14）The files in Android can be opened with the default tool on the Linux.

15）Support Android App quick screenshot sharing.

16）Support Android App to share Linux desktop.

17）Support the scaling of pictures and documents in Android App.

18）Support game key settings.

19）Support Kylin cloud and Huawei cloud.

20）System compatibility, security, stability greatly improved after upgrading to Android 10.

<br>

## Care Instruction
Due to the technical design of Android system and the sharing of hardware resources between Kmre and Kylin operating system, in order to achieve a better use experience, users are advised to read the following notes and known issues carefully:

1）The performance of APP will be greatly improved when using SSD compared to using mechanical hard disk;

2）Do not run more than 4 apps at the same time(Android typically has only one active App running on the front end);

3）Recommended memory 8GB or more;

4）CPU support: FT-2000/4, Phytium D2000/8, FT1500A, Kirin990, Kirin9006C, Hygon, ZHAOXIN, Intel and AMD;

5）Graphics support：NVIDIA, AMD, INTEL, MALI, JJM, GP101 and ZHAOXIN;

6）The voice and video calls were normal but the video was abnormal for qqlite;

7）You need to pause other audio/video playback when using Communication software. Otherwise, audio and video calling software may run into the problem of not hearing the other person's voice;

8）The current version may have a green screen when using the camera on some machines;

9）The machine with a WiFi device, such as a laptop or a desktop computer with Wireless network card. Before starting Kmre, you need to make sure that the WiFi switch is on. Otherwise, if you start Kmre when WiFi is off, all the apps in Kmre will not be connected to the Internet;

10）The screen brightness adjustment feature for video apps will not work;

11）The PIP is not supported;

12）Positioning and sensors are not supported;

13）DingTalk login, if you use the DingTalk to punch in or other functions, you need to log out the account in the Kmre, otherwise there may be "virtual positioning software punch in";

14）Lanxin requires the phone to log out of the account before the voice call function can be used;

15）If the Android App can't connect to the Internet, please check whether the docker network configuration conflicts with the local LAN network configuration;

16）Virtual machine is not supported.

17）The reason why some applications (such as Zhihu) have no network may be related to the wrong time of Linux OS. The time of Android is synchronized with that of Linux. Some Android applications have their own network detection mechanism. When the time of Android is not the current time, App may be forbidden to use the network; The solution to this problem is: Linux synchronizes the current time.

<br>

## Application startup
### Start App from Kylin store
Click the UKUI Menu -> Software Store as Figure 1.When the Kylin Store opens, click the "Mobile Apps" button at the top of the window. If this is the first time you start the application, you need to initialize the Kmre environment. During this process, a prompt box will pop up in the lower right corner of the desktop, as Figure 2. When the Kmre environment is ready, the prompt box exit.The Kylin store "Mobile Apps" page will display a list of mobile apps and you can install them as Figure 3.

![Figure 1 Start Software store from UKUI menu-big](image/1.png)

![Figure 2 Initialize the Kmre-big](image/2.png)

![Figure 3 A list of mobile apps that can be installed](image/3.png)

When the Kmre is ready and the mobile application is installed. You can choose to open your mobile app through the Software Store. Hover the mouse over the installed app, as shown in Figure 4, and click the "Open" button to display the interface of the corresponding mobile app, as shown in Figure 5.

![Figure 4 Start mobile app](image/4.png)

![Figure 5 opening mobile app](image/5.png)

### Launch the mobile application from the UKUI Menu shortcut
Click the UKUI menu in the lower left corner of the desktop, and click the Android app icon to start the app.As shown in figure 6 and figure 7.

![Figure 6 Start the mobile application in Kylin Menu Normal mode-big](image/6.png)

![Figure 7 Start the mobile application in Kylin Menu full screen mode-big](image/7.png)

<br>

## Close the Kmre
### Close
As shown in Figure 8.Select "Close Kmre" from the pop-up menu to close the Kmre and close all Android app Windows.

![Figure 8 Close the Kmre-big](image/8.png)

<br>

## Interface switch
### Switch
When the mobile app is launched, it will have the same TAB in the penal as the system app, as shown in Figure 9. Clicking on the penal Tab activates the corresponding application, and you can switch between applications by Alt+Tab, as shown in Figure 10.

![Figure 9 Click the mobile app icon in the penal](image/9.png)

![Figure 10 Switch by Alt+Tab-big](image/10.png)

### Full-screen mobile app window
You can use the full screen button on the title bar or the shortcut key F11 to make the window full screen display. In the case of full screen display of the window, when the mouse moves in the bottom area of the window, a floating toolbar will appear at the bottom of the interface, as shown in Figure 11. The toolbar has three buttons: return, game key setting and exit full screen.

![Figure 11 Full screen floating toolbar-big](image/11.png)

<br>

## Install and uninstall mobile applications
- Install and update:After the store is opened, click the "Mobile Application" button at the top of the interface, and the list of mobile applications will appear in the window. Move the mouse over the application and click the "Download" button, as shown in Figure 12. After installation, the "Download" button will become the "Open" button.

![Figure 12 Install the application](image/12.png)

- Uninstall：Software store  ->my apps  ->uninstall,Select the software to be uninstalled and click the "Uninstall" button to begin uninstalling,as figure 13.

![Figure 13 Uninstall](image/13.png)

<br>

## Input
### Chinese input
Kmre and Kylin OS share input methods. After switching the input method, you can directly input Chinese in the input box of the mobile application, as shown in Figure 14.

![Figure 14 Chinese input-big](image/14.png)

### Keyboard
Kmre supports keyboard key input, including keypad and various key combinations, such as Ctrl+C, Ctrl+V, etc，as figure 15.

![Figure 15 keyboard](image/15.png)

<br>

## File sharing
In Kylin V10 SP1, Kmre provides Kylin and mobile application environment file interoperability: a plug-in based on file manager Peony, which allows you to view and copy four types of Android files in the file manager: pictures, videos, audio and documents.Android applications can directly access the system's files, greatly facilitating file transfer and access.

* Through the file manager, you can view and access the files in Android, such as the pictures and documents saved through Android wechat. As shown in Figure 16, there is a "mobile application" button on the left side of the file manager. Click this button to display four folder directories: video, picture, document and audio. Users can copy and view files in Android.

![Figure 16 Mobile app data folder](image/16.png)

* Android apps access Kylin data directly(talk Wechat as example)

  - （a）Sends photos:As shown in Figure 17, click the "Album" button of WeChat and select to enter a folder on the pop-up interface to send the pictures in the folder to friends.

  ![Figure 17 Wechat Photo selection entry](image/17.png)

  - （b）Send the document:As shown in Fig. 18, Fig. 19 and Fig. 20, first click the "File" button of WeChat, select "Mobile Storage" on the pop-up interface, and then select "0-Kylin File" to send the files of Kylin to friends.

  ![Figure 18 Select the entry of the document file](image/18.png)

  ![Figure 19 Select the list item for the file](image/19.png)

  ![Figure 20 Select a document file from the phone store](image/20.png)

<br>

## Configure the network
Kmre runs in a Docker container. If the network configuration of Docker is the same as the network segment of the user's machine, such as the network segment beginning with 172, then there will be no network in the Kmre in the container. In this case, you can modify the docker network configuration file /etc/docker/daemon.json and restart kmre to solve the problem. The specific modification method is shown in Figure 21. Click the menu button in the title bar and click "configure" in the pop-up menu to enter the "docker IP" page of the configuration interface. After setting the IP address and subnet mask, restart the system, as shown in Figure 22.

![Figure 21 Configuration entry-big](image/21.png)

![Figure 22 Setting docker IP](image/22.png)

<br>

## Game keyboard whitelist Settings
Kmre can set buttons for game operations, and set the game white list that can use the game buttons through the configuration interface, as shown in Figure 21 above. Click the menu button in the title bar and click "configuration" in the pop-up menu (when kylin kmre environment is not started or Android application is not running, You can open the terminal to execute "kylin-kmre-window --preference" to open the configuration interface, enter the "game white list" page of the configuration interface, add the game name to the white list on the "add" page, and delete the game name from the white list on the "delete" page, as shown in Figure 23 and figure 24. Only the game in the white list can operate the game by setting the mouse button. After the setting is completed, the App needs to be restarted before it takes effect. Click the menu button in the title bar, click "game button" in the pop-up menu to start setting, as shown in Figure 25, the game button style is shown in Figure 26, and the operation effect of the game is shown in Figure 27.

![Figure 23 Add game button white list](image/23.png)

![Figure 24 Remove game name from game white list](image/24.png)

![Figure 25 Game key settings entry](image/25.png)

![Figure 26 Game key effect picture-big](image/26.png)

![Figure 27 Game operation effect picture-big](image/27.png)

<br>

## Display mode switching
Kmre provides two display modes, performance mode and compatibility mode. Performance mode is only applicable to AMD graphics card, while compatibility mode is applicable to all graphics cards. Users can modify it in the "display" page through the "configuration" entry, as shown in Figure 28.

![Figure 28 Display mode switch interface](image/28.png)

<br>

## Renderer switching
Kmre provides four kinds of list of renderers for users to choose. Android automatically selects the renderers according to the hardware environment by default. Users can modify it in the "render" page through the "configuration" portal, as shown in Figure 29.

![Figure 29 renderer switch interface](image/29.png)

<br>

## Idle image cleaning
Kmre provides idle image cleaning function. When users continuously upgrade the kmre image package, there will be more and more images in the container, occupying a lot of disk space. Through the idle image cleaning function, users can clean up the images they no longer need and free up disk space. Users can open the image cleaning interface through the "cleaning up idle images" entry in the menu to select and clean or clean all idle images at one time, as shown in Figure 30 and figure 31.

![Figure 30 Idle image cleaning entrance-big](image/30.png)

![Figure 31 Image cleaning interface](image/31.png)

<br>

## File Drag and Drop
Kmre currently supports drag-drop of files from 9 apps. You can directly drag and drop files from Linux system to the application window for quick sharing. They are: WeChat, qqlite, netease Mail, WeLink, WPS, Baidu netdisk, youdao Cloud Notes, Lanxin+, WeCom; The three apps only support photo sharing: iQIYI, Toutiao and Evernote.

<br>

## Resizable
Kmre supports to resize images and document content: hold down 'Ctrl' while press and hold the left mouse button to move forward and backward.
