# 麒麟移动运行时环境
## 概 述
麒麟移动运行时环境（以下简称为Kmre）是麒麟团队专为“银河麒麟操作系统”打造的一款兼容安卓App运行的系统环境，用于满足用户对应用软件的多样化需求。Kmre能够让用户在银河麒麟操作系统中安装和运行安卓App，比如游戏、微信、QQ极速版、股票、视频类App等。

### 技术特点
1）支持海量安卓App，一秒启动。

2）可直接使用显卡硬件，无性能损失。

3）安卓App与Linux窗口显示融合。

4）多个App同时运行。

5）App分辨率动态适应，横竖屏幕切换，高分辨率真全屏模式。

6）统一输入法，使用Linux输入法在安卓App中输入文字。

7）统一音频设备，支持语音聊天。

8）支持使用摄像头拍照、录像和视频通话，支持摄像头热插拔，即插即用。

9）文件互通，文字剪切板互通，应用管理统一。

10）支持微信、QQ极速版的新消息通知。

11）支持微信平板模式登录，和手机微信同时在线。

12）支持微信、QQ极速版等应用拖拽文件进行分享。

13）支持安卓App直接访问Linux端文件。

14）支持安卓内的文件使用Linux端的默认工具打开。

15）支持安卓App快速截图分享。

16）支持安卓App共享Linux桌面。

17）支持安卓App内图片和文档的缩放。

18）支持游戏按键设置。

19）支持麒麟云和华为云。

20）升级到安卓11，兼容性、安全性、稳定性大幅提升。

<br>

## 用前必读
因安卓系统本身技术设计，以及Kmre与银河麒麟操作系统共用硬件资源的原因，为了达到较好的使用体验效果，建议用户仔细阅读以下注意事项和已知问题：

1）安卓App在使用固态硬盘时性能会相较于使用机械硬盘有较大提升（安卓操作系统为手机操作系统，其磁盘操作对机械硬盘支持较差）；

2）建议不要同时运行4个以上的App（安卓手机一般只会有一个App在前端活跃运行）；

3）电脑内存建议8G或以上；

4）当前版本支持的处理器包括FT-2000/4、Phytium D2000/8、FT1500A、Kirin990、Kirin9006C、Hygon、ZHAOXIN、Intel和AMD；

5）当前版本支持的显卡包括：NVIDIA、AMD、INTEL、MALI、JJM、GP101和ZHAOXIN；

6）QQ极速版语音和视频通话正常，但是录像显示异常；

7）在使用音视频通话软件时，需要暂停其他音频/视频的播放，否则音视频通话软件可能会遇到听不到对方声音的问题；

8）当前版本在有些机器上使用摄像头可能存在绿屏现象；

9）带有wifi设备的机器，如笔记本或者台式机插入了无线网卡，这类机器在启动Kmre环境之前，需要保证wifi开关处于开启状态，否则如果wifi开关处于关闭状态时启动Kmre环境，则Kmre环境里的App都无法联网；

10）视频类应用调节屏幕亮度功能不会生效；

11）视频类应用不支持“画中画”功能；

12）不支持定位和传感器相关功能；

13）“钉钉”应用登录后，如在钉钉上使用到打卡等功能，需要先在Kmre环境中登出账号，否则可能出现“虚拟定位软件打卡”问题；

14）“蓝信+”应用，需要在手机上登出账号后，语音通话功能才能成功呼出；

15）如果安卓应用无法连接互联网，请检查是否是docker网络配置与本机局域网的网络配置存在冲突；

16）不支持虚拟机；

17）部分应用（如知乎）出现无网络的原因可能与Linux系统时间不对有关，安卓系统内部与Linux系统时间同步，某些安卓应用内部有自己的网络检测机制，当安卓系统时间不是当前时间时，可能会禁止应用使用网络；解决该问题的方法是：Linux系统同步当前时间。

<br>

## 移动应用启动方式
### 从麒麟软件商店启动移动应用
点击左下角开始菜单->软件商店，如图 1所示。软件商店打开后，点击窗口上方的“移动应用”按钮。若为开机后第一次启动应用，则需初始化Kmre环境，在该过程中，桌面右下角会弹出提示框，如图 2所示。待Kmre环境准备完成后，提示框退出，软件商店“移动应用”页面将会出现移动应用列表，此时可以开始进行移动应用的安装，如图 3所示。

![图 1 从开始菜单启动软件商店-big](image/1.png)

![图 2 初始化Kmre环境提示框-big](image/2.png)

![图 3 可安装的移动应用列表](image/3.png)

当Kmre环境准备完毕，并且安装了移动应用后，我们可以选择通过软件商店打开移动应用。鼠标悬停在已安装应用上，如图 4所示，点击“打开”按钮，出现对应移动应用的界面，如图 5所示。

![图 4 打开移动应用](image/4.png)

![图 5 打开的移动应用软件](image/5.png)

### 从开始菜单快捷方式启动移动应用
点击桌面左下角开始菜单，点击对应的安卓应用的图标开始启动应用，如图 6和图 7所示。

![图 6 在开始菜单正常模式中启动移动应用-big](image/6.png)

![图 7 在开始菜单全屏模式中启动移动应用-big](image/7.png)

<br>

## 关闭移动运行时环境
### 关闭
如图 8所示，在弹出的菜单中选择“关闭麒麟移动运行时环境”，则可将打开的麒麟移动运行时环境关闭，并关闭所有安卓应用的图形窗口。

![图 8 关闭麒麟移动运行时环境-big](image/8.png)

<br>

## 界面切换
### 切换
移动应用启动后，与麒麟系统应用一样，在任务栏有个对应的标签，如图 9所示。点击任务栏标签可以激活对应的应用，并且可以通过Alt+Tab键进行应用间的切换，如图 10所示。

![图 9 点击任务栏移动应用图标](image/9.png)

![图 10 Alt+Tab切换-big](image/10.png)

### 移动应用窗口的全屏
可以使用标题栏上的全屏按钮或者快捷键F11让窗口全屏显示，在窗口全屏显示的情况下，当鼠标在窗口最下方区域移动时，界面最下方将出现一个浮动工具栏，如图 11所示，该工具栏上有返回、游戏按键设置、退出全屏三个按钮。

![图 11 全屏状态下的浮动工具栏-big](image/11.png)

<br>

## 安装卸载移动应用
- 安装和升级：软件商店打开后，点击界面上方的“移动应用”按钮，视窗中会出现移动应用列表，鼠标移至应用处，点击“下载”按钮即可，如图 12所示。安装过后，该“下载”按钮将会变成“打开”按钮。

![图 12 安装应用](image/12.png)

- 卸载：进入“软件商店” ->“我的” -> “应用卸载”页面，选中需要卸载的软件，点击“卸载”按钮开始卸载，如图 13。

![图 13 卸载应用](image/13.png)

<br>

## 输入
### 中文输入
Kmre环境和麒麟系统环境共享输入法，切换输入法后，可以直接在移动应用的输入框中输入中文，如图 14所示。

![图 14 中文输入-big](image/14.png)

### 按键输入
Kmre支持键盘按键输入，包括小键盘和各类组合键，如Ctrl+C、Ctrl+V等，如图 15所示。

![图 15 按键输入](image/15.png)

<br>

## 文件互通
在银河麒麟操作系统V10 SP1上，Kmre提供了麒麟与移动运行时环境文件互通功能：一个基于文件管理器peony的插件，通过该插件可以在文件管理器中查看和拷贝安卓内的四类文件：图片、视频、音频和文档；并且，安卓应用可以直接访问麒麟端的文件，大大方便了文件传输和访问。

* 通过文件管理器查看和访问安卓内的文件，如通过安卓微信保存的图片、文档等都可以在该插件查看。如图 16所示，在文件管理器左侧有个“移动应用”按钮，点击该按钮，出现四个文件夹目录：视频、图片、文档、音频，用户可以对安卓里的文件进行拷贝、查看等操作。

![图 16 移动应用数据文件夹](image/16.png)

* 安卓应用直接访问麒麟端数据（以微信发送文件为例进行描述）

  - （a）微信发送照片：如图 17所示，先点击微信的“相册”按钮，在弹出的界面上选择进入某个文件夹，即可将文件夹中的图片发送给好友。

  ![图 17 微信选择照片的入口](image/17.png)

  - （b）微信发送文档：如图 18、图 19和图 20所示，先点击微信的“文件”按钮，在弹出的界面上选择“手机存储”，然后再选择“0-麒麟文件”即可将麒麟端的文件发送给好友。

  ![图 18 微信选择文档文件的入口](image/18.png)

  ![图 19 微信选择文件的列表项](image/19.png)

  ![图 20 微信从手机存储选择文档文件](image/20.png)

<br>

## 修改网络配置
Kmre运行在docker容器中，如果docker的网络配置与用户机器所在网络的网段一样，如172开头的网段，此时会造成容器中的麒麟移动运行时环境没有网络。遇到这种情况，可以修改docker的网络配置文件 /etc/docker/daemon.json后重启麒麟移动运行时环境解决该问题，具体修改办法如图 21所示，点击标题栏的菜单按钮，在弹出菜单中点击“配置”，进入配置界面的“Docker IP”页面，设置好IP地址和子网掩码后重启系统，如图 22所示。

![图 21 配置入口-big](image/21.png)

![图 22 设置Docker IP](image/22.png)

<br>

## 游戏按键白名单设置
Kmre可以为游戏设置按键进行游戏操作，通过配置界面设置可以使用游戏按键的游戏白名单，如上图 21所示，点击标题栏的菜单按钮，在弹出菜单中点击“配置”（在Kmre环境未启动或者没有Android应用运行的情况下，可以打开终端执行 “kylin-kmre-window --preference”打开配置界面），进入配置界面的“游戏白名单”页面，在“添加”页面添加游戏名到白名单，在“删除”页面可以将游戏名从白名单中删除，如图 23和图 24所示。只有在白名单中的游戏才可以通过设置鼠标按键来操作游戏，设置完成后，需要重新启动对应的应用后才生效。点击标题栏的菜单按钮，在弹出菜单中点击“游戏按键”，开始进行设置，如图 25所示，游戏按键样式如图 26所示，游戏操作效果如图 27所示。

![图 23 添加游戏按键白名单](image/23.png)

![图 24 从游戏白名单中删除游戏名](image/24.png)

![图 25 游戏按键设置入口](image/25.png)

![图 26 游戏按键效果图-big](image/26.png)

![图 27 游戏操作效果图](image/27.png)

<br>

## 显示模式切换
Kmre提供两种显示模式，性能模式和兼容模式，其中性能模式只适用于AMD显卡，兼容模式适用于所用显卡。用户可以通过“配置”入口，在“显示”页面中进行修改，如图 28所示。

![图 28 显示模式切换界面](image/28.png)

<br>

## 渲染器切换
Kmre提供四种渲染器列表供用户选择，其中“默认”由安卓根据硬件环境自动选择渲染器。用户可以通过“配置”入口，在“渲染器”页面中进行修改，如图 29所示。

![图 29 渲染器切换界面](image/29.png)

<br>

## 闲置镜像清理
Kmre提供闲置镜像清理功能，当用户不断升级kmre镜像包后，容器中的镜像会越来越多，占据了很多的磁盘空间，通过闲置镜像清理功能可以将用户不再需要的镜像清理干净，腾出磁盘空间。用户可以通过菜单中的“清理闲置的镜像”入口打开镜像清理界面进行选择清理或者一次性清理所有闲置镜像，如图 30和图 31所示。

![图 30 闲置镜像清理入口-big](image/30.png)

![图 31 镜像清理界面](image/31.png)

<br>

## 文件拖拽
Kmre目前支持9款应用的文件拖拽，可以直接将Linux系统上的文件拖拽到应用窗口上进行快捷分享，分别是：微信、QQ极速版、网易邮箱、Welink、WPS、百度网盘、有道云笔记、蓝信+、企业微信；对3款应用只支持图片分享，分别是：爱奇艺、今日头条、印象笔记。

<br>

## 放大缩小
Kmre支持对图片和文档内容的放大缩小：按住“Ctrl”键，并按住鼠标左键进行前后左右移动。
